package dev.shadowsoffire.apotheosis.ench;

import net.minecraft.core.Direction;
import net.minecraft.world.phys.Vec3;
import net.minecraft.client.particle.EnchantmentTableParticle;
import net.minecraft.core.particles.ParticleType;
import net.minecraftforge.client.event.RegisterParticleProvidersEvent;
import dev.shadowsoffire.apotheosis.ench.library.EnchLibraryScreen;
import net.minecraft.client.gui.screens.MenuScreens;
import dev.shadowsoffire.apotheosis.ench.table.ApothEnchantScreen;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.client.renderer.blockentity.BlockEntityRenderers;
import net.minecraft.client.renderer.blockentity.EnchantTableRenderer;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.network.chat.Style;
import net.minecraft.client.gui.screens.Screen;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import dev.shadowsoffire.apotheosis.util.DrawsOnLeft;
import dev.shadowsoffire.placebo.util.EnchantmentUtils;
import net.minecraft.client.resources.language.I18n;
import java.util.ArrayList;
import net.minecraft.world.inventory.AnvilMenu;
import net.minecraft.client.gui.screens.inventory.AnvilScreen;
import net.minecraftforge.client.event.ScreenEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import java.util.Map;
import java.util.Iterator;
import java.util.Set;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.Block;
import java.util.List;
import net.minecraft.world.item.Item;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.fml.ModList;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.level.LevelReader;
import dev.shadowsoffire.apotheosis.ench.api.IEnchantingBlock;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingStatRegistry;
import net.minecraft.core.BlockPos;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.Level;
import net.minecraft.world.item.context.BlockPlaceContext;
import net.minecraft.world.InteractionHand;
import net.minecraft.client.Minecraft;
import net.minecraft.world.item.BlockItem;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.Component;
import net.minecraft.world.item.Items;
import net.minecraftforge.event.entity.player.ItemTooltipEvent;
import net.minecraft.world.phys.BlockHitResult;

public class EnchModuleClient
{
    static BlockHitResult res;
    
    @SubscribeEvent
    public void tooltips(final ItemTooltipEvent e) {
        final Item i = e.getItemStack().m_41720_();
        final List<Component> tooltip = e.getToolTip();
        if (i == Items.f_41863_) {
            tooltip.add((Component)Component.m_237115_("info.apotheosis.cobweb").m_130940_(ChatFormatting.GRAY));
        }
        else if (i == Ench.Items.PRISMATIC_WEB.get()) {
            tooltip.add((Component)Component.m_237115_("info.apotheosis.prismatic_cobweb").m_130940_(ChatFormatting.GRAY));
        }
        else if (i instanceof final BlockItem blockItem) {
            final Block block = blockItem.m_40614_();
            final Level world = (Level)Minecraft.m_91087_().f_91073_;
            if (world == null || Minecraft.m_91087_().f_91074_ == null) {
                return;
            }
            final BlockPlaceContext ctx = new BlockPlaceContext(world, Minecraft.m_91087_().f_91074_, InteractionHand.MAIN_HAND, e.getItemStack(), EnchModuleClient.res) {};
            BlockState state = null;
            try {
                state = block.m_5573_(ctx);
            }
            catch (final Exception ex) {
                EnchModule.LOGGER.trace(ex.getMessage());
                final StackTraceElement[] stackTrace;
                final StackTraceElement[] trace = stackTrace = ex.getStackTrace();
                for (int length = stackTrace.length, j = 0; j < length; ++j) {
                    final StackTraceElement traceElement = stackTrace[j];
                    EnchModule.LOGGER.trace("\tat " + traceElement);
                }
            }
            if (state == null) {
                state = block.m_49966_();
            }
            final float maxEterna = EnchantingStatRegistry.getMaxEterna(state, world, BlockPos.f_121853_);
            final float eterna = EnchantingStatRegistry.getEterna(state, world, BlockPos.f_121853_);
            final float quanta = EnchantingStatRegistry.getQuanta(state, world, BlockPos.f_121853_);
            final float arcana = EnchantingStatRegistry.getArcana(state, world, BlockPos.f_121853_);
            final float rectification = EnchantingStatRegistry.getQuantaRectification(state, world, BlockPos.f_121853_);
            final int clues = EnchantingStatRegistry.getBonusClues(state, world, BlockPos.f_121853_);
            final boolean treasure = ((IEnchantingBlock)state.m_60734_()).allowsTreasure(state, (LevelReader)world, BlockPos.f_121853_);
            if (eterna != 0.0f || quanta != 0.0f || arcana != 0.0f || rectification != 0.0f || clues != 0) {
                tooltip.add((Component)Component.m_237115_("info.apotheosis.ench_stats").m_130940_(ChatFormatting.GOLD));
            }
            if (eterna != 0.0f) {
                if (eterna > 0.0f) {
                    tooltip.add((Component)Component.m_237110_("info.apotheosis.eterna.p", new Object[] { String.format("%.2f", eterna), String.format("%.2f", maxEterna) }).m_130940_(ChatFormatting.GREEN));
                }
                else {
                    tooltip.add((Component)Component.m_237110_("info.apotheosis.eterna", new Object[] { String.format("%.2f", eterna) }).m_130940_(ChatFormatting.GREEN));
                }
            }
            if (quanta != 0.0f) {
                tooltip.add((Component)Component.m_237110_("info.apotheosis.quanta" + ((quanta > 0.0f) ? ".p" : ""), new Object[] { String.format("%.2f", quanta) }).m_130940_(ChatFormatting.RED));
            }
            if (arcana != 0.0f) {
                tooltip.add((Component)Component.m_237110_("info.apotheosis.arcana" + ((arcana > 0.0f) ? ".p" : ""), new Object[] { String.format("%.2f", arcana) }).m_130940_(ChatFormatting.DARK_PURPLE));
            }
            if (rectification != 0.0f) {
                tooltip.add((Component)Component.m_237110_("info.apotheosis.rectification" + ((rectification > 0.0f) ? ".p" : ""), new Object[] { String.format("%.2f", rectification) }).m_130940_(ChatFormatting.YELLOW));
            }
            if (clues != 0) {
                tooltip.add((Component)Component.m_237110_("info.apotheosis.clues" + ((clues > 0) ? ".p" : ""), new Object[] { String.format("%d", clues) }).m_130940_(ChatFormatting.DARK_AQUA));
            }
            if (treasure) {
                tooltip.add((Component)Component.m_237115_("info.apotheosis.allows_treasure").m_130940_(ChatFormatting.GOLD));
            }
            final Set<Enchantment> blacklist = ((IEnchantingBlock)state.m_60734_()).getBlacklistedEnchantments(state, (LevelReader)world, BlockPos.f_121853_);
            if (blacklist.size() > 0) {
                tooltip.add((Component)Component.m_237115_("info.apotheosis.filter").m_130938_(s -> s.m_178520_(5812428)));
                for (final Enchantment ench : blacklist) {
                    final MutableComponent name = (MutableComponent)ench.m_44700_(1);
                    name.m_7360_().clear();
                    name.m_130938_(s -> s.m_178520_(5798058));
                    tooltip.add((Component)Component.m_237113_(" - ").m_7220_((Component)name).m_130938_(s -> s.m_178520_(5798058)));
                }
            }
        }
        else if (i == Items.f_42690_) {
            final ItemStack stack = e.getItemStack();
            final Map<Enchantment, Integer> enchMap = EnchantmentHelper.m_44831_(stack);
            if (enchMap.size() == 1) {
                final Enchantment ench2 = enchMap.keySet().iterator().next();
                final int lvl = enchMap.values().iterator().next();
                if (!ModList.get().isLoaded("enchdesc") && "apotheosis".equals(ForgeRegistries.ENCHANTMENTS.getKey((Object)ench2).m_135827_())) {
                    tooltip.add((Component)Component.m_237115_(ench2.m_44704_() + ".desc").m_130940_(ChatFormatting.DARK_GRAY));
                }
                if (EnchConfig.showEnchantedBookMetadata) {
                    final EnchantmentInfo info = EnchModule.getEnchInfo(ench2);
                    final Object[] args = { boolComp("info.apotheosis.discoverable", info.isDiscoverable()), boolComp("info.apotheosis.lootable", info.isLootable()), boolComp("info.apotheosis.tradeable", info.isTradeable()), boolComp("info.apotheosis.treasure", info.isTreasure()) };
                    if (e.getFlags().m_7050_()) {
                        tooltip.add((Component)Component.m_237110_("%s ┇ %s ┇ %s ┇ %s", new Object[] { args[0], args[1], args[2], args[3] }).m_130940_(ChatFormatting.DARK_GRAY));
                        tooltip.add((Component)Component.m_237110_("info.apotheosis.book_range", new Object[] { info.getMinPower(lvl), info.getMaxPower(lvl) }).m_130940_(ChatFormatting.GREEN));
                    }
                    else {
                        tooltip.add((Component)Component.m_237110_("%s ┇ %s", new Object[] { args[2], args[3] }).m_130940_(ChatFormatting.DARK_GRAY));
                    }
                }
            }
        }
    }
    
    @SubscribeEvent
    public void drawAnvilCostBlob(final ScreenEvent.Render.Post e) {
        final Screen screen = e.getScreen();
        if (screen instanceof final AnvilScreen anv) {
            final int level = ((AnvilMenu)anv.m_6262_()).m_39028_();
            if (level <= 0 || !((AnvilMenu)anv.m_6262_()).m_38853_(((AnvilMenu)anv.m_6262_()).m_266562_()).m_6657_()) {
                return;
            }
            final List<Component> list = new ArrayList<Component>();
            list.add((Component)Component.m_237113_(I18n.m_118938_("info.apotheosis.anvil_at", new Object[] { level })).m_130944_(new ChatFormatting[] { ChatFormatting.UNDERLINE, ChatFormatting.GREEN }));
            final int expCost = EnchantmentUtils.getTotalExperienceForLevel(level);
            list.add((Component)Component.m_237110_("info.apotheosis.anvil_xp_cost", new Object[] { Component.m_237113_("" + expCost).m_130940_(ChatFormatting.GREEN), Component.m_237113_("" + level).m_130940_(ChatFormatting.GREEN) }));
            DrawsOnLeft.draw((AbstractContainerScreen)anv, e.getGuiGraphics(), (List)list, anv.getGuiTop() + 28);
        }
    }
    
    private static Component boolComp(final String key, final boolean flag) {
        return (Component)Component.m_237115_(key + (flag ? "" : ".not")).m_130948_(Style.f_131099_.m_178520_(flag ? 1083408 : 11146774));
    }
    
    public static void init() {
        BlockEntityRenderers.m_173590_(BlockEntityType.f_58928_, EnchantTableRenderer::new);
        MenuScreens.m_96206_((MenuType)Apoth.Menus.ENCHANTING_TABLE.get(), ApothEnchantScreen::new);
        MenuScreens.m_96206_((MenuType)Apoth.Menus.LIBRARY.get(), EnchLibraryScreen::new);
    }
    
    @SubscribeEvent
    public static void particleFactories(final RegisterParticleProvidersEvent e) {
        e.registerSpriteSet((ParticleType)Apoth.Particles.ENCHANT_FIRE.get(), EnchantmentTableParticle.Provider::new);
        e.registerSpriteSet((ParticleType)Apoth.Particles.ENCHANT_WATER.get(), EnchantmentTableParticle.Provider::new);
        e.registerSpriteSet((ParticleType)Apoth.Particles.ENCHANT_SCULK.get(), EnchantmentTableParticle.Provider::new);
        e.registerSpriteSet((ParticleType)Apoth.Particles.ENCHANT_END.get(), EnchantmentTableParticle.Provider::new);
    }
    
    static {
        EnchModuleClient.res = BlockHitResult.m_82426_(Vec3.f_82478_, Direction.NORTH, BlockPos.f_121853_);
    }
}
